#KERNCONF=GENERIC
KERNCONF=RPI3
RPI3_UBOOT_PORT="u-boot-rpi3"
RPI3_UBOOT_BIN="u-boot.bin"
RPI3_UBOOT_PATH="/usr/local/share/u-boot/${RPI3_UBOOT_PORT}"
IMAGE_SIZE=$((2000 * 1000 * 1000))
TARGET_ARCH=aarch64
TARGET=aarch64

# Not used - just in case someone wants to use a manual ubldr.  Obtained
# from 'printenv' in boot0: kernel_addr_r=0x42000000
#UBLDR_LOADADDR=0x42000000

rpi3_check_uboot ( ) {
    uboot_port_test ${RPI3_UBOOT_PORT} ${RPI3_UBOOT_BIN}
}
strategy_add $PHASE_CHECK rpi3_check_uboot

#
# RPi3 uses EFI, so the first partition will be a FAT partition.
#
rpi3_partition_image ( ) {
    disk_partition_mbr
    # Use FAT16.  The minimum space requirement for FAT32 is too big for this.
    disk_fat_create 50m 16
    disk_ufs_create
}
strategy_add $PHASE_PARTITION_LWW rpi3_partition_image

raspberry_pi_populate_boot_partition ( ) {
    echo bootaa64 > startup.nsh
    mkdir -p EFI/BOOT/dtb
    # Copy RaspberryPi 3 boot files to FAT partition
    cp ${UBOOT_PATH}/LICENCE.broadcom .
    cp ${UBOOT_PATH}/README .
    cp ${UBOOT_PATH}/bootcode.bin .
    cp ${UBOOT_PATH}/config.txt .
    cp ${UBOOT_PATH}/fixup.dat .
    cp ${UBOOT_PATH}/fixup_cd.dat .
    cp ${UBOOT_PATH}/fixup_x.dat .
    cp ${UBOOT_PATH}/start.elf .
    cp ${UBOOT_PATH}/start_cd.elf .
    cp ${UBOOT_PATH}/start_x.elf .
    cp ${UBOOT_PATH}/u-boot.bin .

    # RPi firmware loads and modify the DTB before pass it to kernel.
echo about to do freebsd_install_fdt rpi3.dts rpi3.dtb
    freebsd_install_fdt rpi3.dts rpi3.dtb
    # and for EFI boot dtb
echo about to do freebsd_install_fdt rpi3.dts dtb/rpi3.dtb
    mkdir dtb
    freebsd_install_fdt rpi3.dts dtb/rpi3.dtb
}
strategy_add $PHASE_BOOT_INSTALL raspberry_pi_populate_boot_partition

# Build & install loader.efi.
strategy_add $PHASE_BUILD_OTHER freebsd_loader_efi_build
strategy_add $PHASE_BOOT_INSTALL freebsd_loader_efi_copy EFI/BOOT/bootaa64.efi

# RPi3 puts the kernel on the FreeBSD UFS partition.
strategy_add $PHASE_FREEBSD_BOARD_INSTALL board_default_installkernel .
# overlay/etc/fstab mounts the FAT partition at /boot/efi
strategy_add $PHASE_FREEBSD_BOARD_INSTALL mkdir -p boot/efi
